wmmenu(1)

NAME

wmmenu - A WindowMaker dockapp to launch programs with a popup pixmap menu

SYNTAX

wmmenu [<options>] -m <MENUNAME>
wmmenu -v
wmmenu -h

DESCRIPTION

This is a "dock application" for Windowmaker, that provides a button bar to launch applications from.

The bar opens automatically when either the mouse enters the button or you click on it (this is configurable).

Multiple instances of the program can run at the same time: each one provides a menu that it reads from a separate file, so you can have as many different menus as you want (you can also display the same menu more than once if you want; dunno what it's useful for...).

NOTE: options can take place before or after "-m", as long as each option is correctly paired with its corresponding argument (when it has one).

OPTIONS

-h  print a help message listing known options.

-v  print version information

-g WxH
    force width and height of tile

-l XPMFILE
    set filename of the pixmap used to highlight icon under cursor

-t XPMFILE
    set filename of the pixmap used as button bar background. XPMFILE may also be '!COMMAND' to execute COMMAND and get the pixmap name to use from its output.

-O click
    bar is only triggered by clicks on the tile, not moves

-O noautoscale
    disable automatic pixmap scaling to tile size

-O behind
    draw highlight pixmap behind icon, not above

-O hide=N
    set bar hiding timeout in ms. See hide_timeout description in Defaults.

-r ROWS
    set number of menu rows (default one)

Please note, that -l, -t and -O behind options can also be specified with another syntax in the defaults file (described hereafter).

DEFAULTS FILE
This is a configuration file that defines things common to all instances of wmmenu. It is located in "~/.wmmenu/defaults".

The syntax is as follows:

# comment or empty lines are ignored

xpmpath PATH1:PATH2:...
xpmpath PATH3
xpmpath PATH4
# defines in which path to search for pixmaps

tile FILE.XPM
 or
tile /SOME/PATH/TO/FILE.XPM
# defines pixmap used as background tile in menu bar
 or
tile !some_command with arguments
# defines the command to call to get the pixmap name to be # used: the name is read from its standard output. # If the name read is empty, the internal default is used # instead.

highlight FILE.XPM
 or
highlight /SOME/PATH/TO/FILE.XPM
# defines pixmap used to highlight item under cursor

highlight_behind[ ANYTHING_NOT_EMPTY]
# (don't forget the separating space)
# request to draw highlight pixmap BEHIND icon,
# no more in front.
# To be used if your pixmap is designed to cover most
# of tile's surface

hide_timeout MS
# set the delay, in ms, necessary for the bar to close
# after the cursor has left wmmenu. 1 by default.

MENU FILES
Those files each define a menu of their own. Each menu file is located in "~/.wmmenu/<MENUNAME>"; The name of the file determines the name you must use on command-line to call it.

The syntax is the following:

# comment and blank lines are ignored

"MENUICON.XPM"	menu title
    There is exactly one such line in each menu file, and is the first significant line encountered. It describes the menu name, which may be used by your window manager, and the pixmap that is shown to trigger the menu. The pixmap is specified using the same rules as the next item (read on).

"ICON.XPM"	command arguments &
    ICON.XPM is an image filename or path. It can be an absolute path (begins with "/"), a path relative to wmmenu's current directory (contains a "/" but not at the beginning), a path relative to home directory (starts with "~/"), or a simple file name (searched through all defined xpmpath elements). If you compiled wmmenu with gdk-pixbuf support, the image can be any format supported by this library (GIF, PNG, TIFF, JPEG, etc...); Otherwise only XPM is supported.
    command and arguments are run with the system(3) library call, hence: 1/ you can use any shell tricks you want, and 2/ wmmenu waits for command completion, so for X11 programs you have to add "&" at the end.

FILES

~/.wmmenu/<MENUNAME>
~/.wmmenu/defaults

ENVIRONMENT VARIABLES

HOME
    Specifies the home directory

EXAMPLES

I personally use the following command line:

wmmenu -m apps -r 3

BUGS

If wmmenu was not compiled with gdk-pixbuf support, application icons larger than tile overlap over icons next to them. With gdk-pixbuf support turned on, images in this case are automatically scaled down to fit to tile (unless "-O noautoscale" was specified).

There is some flicker when the mouse goes from the dockapp to the menu bar. On fast displays this is not always apparent.

No editor is provided, to edit menu files. However, editing by hand is not so difficult, and menu files are automatically reloaded each time you save them. You only have to restart wmmenu, if you change any setting in the defaults file.

AUTHORS

Fabien COUTANT <fcoutant@freesurf.fr>

SEE ALSO

rox-menu, wmaker